// Generated by CoffeeScript 1.10.0
(function() {
  var Browser, BrowserWindow, Watcher, app, chokidar, cson, exec, fork, fs, fse, ipc, mainWindow,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  fse = require("fs-extra");

  chokidar = require("chokidar");

  cson = require("cson");

  fs = require("fs");

  exec = require("child_process").exec;

  fork = require("child_process").fork;

  app = require('app');

  BrowserWindow = require('browser-window');

  ipc = require('electron').ipcMain;

  mainWindow = null;

  Watcher = (function() {
    function Watcher() {
      this.start = bind(this.start, this);
      this.restart = bind(this.restart, this);
    }

    Watcher.prototype.restart = function() {
      var cmd;
      if (!this.restartFlg) {
        cmd = fse.readJsonSync("package.json").scripts.electron;
        exec(cmd);
      }
      this.restartFlg = true;
      return setTimeout(app.quit, 0);
    };

    Watcher.prototype.start = function() {
      return chokidar.watch(["./browser/.build/"]).on("change", (function(_this) {
        return function(path) {
          if (!path.match(/\.js$/)) {
            return;
          }
          return _this.restart();
        };
      })(this));
    };

    return Watcher;

  })();

  module.exports = Browser = (function() {
    function Browser() {
      this.sendMsg = bind(this.sendMsg, this);
      this.ipcEvent = bind(this.ipcEvent, this);
      this.start = bind(this.start, this);
      this.init = bind(this.init, this);
    }

    Browser.prototype.configCson = ".config.cson";

    Browser.prototype.init = function() {
      var error;
      try {
        this.config = cson.load(this.configCson);
      } catch (error) {
        this.config = require("./config.cson");
      }
      this.option = this.config.browserWindow;
      return this;
    };

    Browser.prototype.start = function() {
      this.url = this.config.browserWindow.webPreferences.url;
      this.watcher = new Watcher();
      this.watcher.start();
      this.ipcEvent();
      app.on('window-all-closed', (function(_this) {
        return function() {
          if (process.platform !== 'darwin') {
            return app.quit();
          }
        };
      })(this));
      return app.on('ready', (function(_this) {
        return function() {
          var option;
          option = JSON.parse(JSON.stringify(_this.option));
          option.webPreferences.preload = "" + (process.cwd()) + _this.option.webPreferences.preload;
          mainWindow = _this.mainWindow = new BrowserWindow(option);
          mainWindow.setAlwaysOnTop(true);
          if (!_this.url.match(/^(http|\/\/)/)) {
            _this.url = "file://" + (process.cwd()) + _this.url;
          }
          mainWindow.loadURL(_this.url);
          mainWindow.openDevTools();
          mainWindow.webContents.on("did-finish-load", function() {
            if (!_this.option["always-on-top"]) {
              return mainWindow != null ? mainWindow.setAlwaysOnTop(false) : void 0;
            }
          });
          mainWindow.on('closed', function() {
            return mainWindow = null;
          });
          mainWindow.on("close", function(e) {
            var csonString, wh, xy;
            if (!(mainWindow != null ? mainWindow.getPosition : void 0)) {
              return;
            }
            xy = mainWindow.getPosition();
            wh = mainWindow.getSize();
            _this.option.x = xy[0];
            _this.option.y = xy[1];
            _this.option.width = wh[0];
            _this.option.height = wh[1];
            csonString = cson.createCSONString(_this.config, {
              indent: "  "
            });
            fs.writeFileSync(_this.configCson, csonString);
            return mainWindow = null;
          });
          return mainWindow.on('app-command', function(e, cmd) {
            if (cmd === 'browser-backward' && mainWindow.webContents.canGoBack()) {
              return mainWindow.webContents.goBack();
            } else if (cmd === 'browser-forward' && mainWindow.webContents.canGoForward()) {
              return mainWindow.webContents.goForward();
            }
          });
        };
      })(this));
    };

    Browser.prototype.ipcEvent = function() {
      return ipc.on('inspect element', (function(_this) {
        return function(e, arg, renderer) {
          return _this[renderer].inspectElement(arg.x, arg.y);
        };
      })(this)).on("restart", this.watcher.restart);
    };

    Browser.prototype.startCompiler = function() {
      return exec(fse.readJsonSync("package.json").scripts.watch).stdout.on("data", this.sendMsg);
    };

    Browser.prototype.sendMsg = function(msg) {
      return mainWindow != null ? mainWindow.webContents.send("browser send msg", msg) : void 0;
    };

    return Browser;

  })();

}).call(this);
